<?php

if ( !class_exists( 'Plvc_Multiple_Config' ) ) :

class Plvc_Multiple_Config
{

	function __construct() {
		
		add_action( 'plvc_init' , array( $this , 'init' ) );
		
	}
	
	public function init()
	{
		
		$this->setup_config();
		$this->setup_links();

	}

	function setup_config() {
		
		global $Plvc_Multiple;
		
		$Plvc_Multiple->Plugin['nonces']     = array( 'field' => $Plvc_Multiple->ltd . '_field' , 'value' => $Plvc_Multiple->ltd . '_value' );
		$Plvc_Multiple->Plugin['msg_notice'] = $Plvc_Multiple->ltd . '_msg';
		
	}

	function setup_links() {
		
		global $Plvc_Multiple;
		global $Plvc;
		
		$Plvc_Multiple->Plugin['links']['contact'] = $Plvc->ClassInfo->author_url( array( 'contact' => 1 , 'tp' => 'use_addon' , 'lc' => 'use_addon' ) );
		$Plvc_Multiple->Plugin['links']['about'] = $Plvc->ClassInfo->author_url( array( 'add-on' => 1 , 'tp' => 'use_addon' , 'lc' => 'use_addon' ) );

		if( $Plvc->Current['multisite'] ) {

			$Plvc_Multiple->Plugin['links']['setting'] = admin_url( 'admin.php?page=' . $Plvc_Multiple->main_slug );

		} else {

			$Plvc_Multiple->Plugin['links']['setting'] = admin_url( 'admin.php?page=' . $Plvc_Multiple->main_slug );

		}

	}
	
	function get_rewrite_redords_name() {
		
		global $Plvc;

		$records = array();
		$rewrite_name =  array( 'post' , 'page' , 'media' , 'comments' , 'widgets' , 'menus' , 'menus_adv' , 'custom_posts' , 'users' );
		
		foreach( $Plvc->Plugin['record'] as $name => $record_name ) {
			
			if( in_array( $name , $rewrite_name ) )
				$records[$name] = $record_name;
		}
		
		return $records;

	}

}

endif;
