<?php

if ( !class_exists( 'Plvc_Multiple_Data' ) ) :

class Plvc_Multiple_Data
{

	function init() {
		
		global $Plvc_Multiple;
		global $Plvc;
		
		if( $Plvc->Current['admin'] && $Plvc->ClassManager->is_manager && !$Plvc->Current['ajax'] ) {
			
			add_action( 'admin_init' , array( $this , 'dataUpdate' ) );
		
		}

	}




	function dataUpdate() {
		
		global $Plvc_Multiple;
		global $Plvc;
		
		$RecordField = false;
		$form_field = $Plvc->Plugin['ltd'] . '_settings';
		
		if( !empty( $_POST ) && !empty( $Plvc->ClassManager->is_manager ) && !empty( $_POST[$form_field] ) && $_POST[$form_field] == $Plvc->Plugin['UPFN'] ) {
			
			if( !empty( $_POST[$Plvc_Multiple->ltd . '_role_data_copy'] ) ) {
				
				$nonce_key = $Plvc_Multiple->ltd . '_role_data_copy';
	
				if(	check_admin_referer( $nonce_key , $nonce_key ) ) {

					$this->copy_user_role_data();
				
				}

			}

			if( !empty( $_POST[$Plvc_Multiple->ltd . '_original_data_copy'] ) ) {
				
				$nonce_key = $Plvc_Multiple->ltd . '_original_data_copy';
	
				if(	check_admin_referer( $nonce_key , $nonce_key ) ) {

					$this->copy_original_data();
				
				}

			}

		}

	}

	private function copy_user_role_data() {
		
		global $Plvc_Multiple;
		global $Plvc;

		if( empty( $_POST['plvc_user_role_name'] ) or empty( $_POST['copy_from'] ) or empty( $_POST['record_field'] ) or empty( $_POST['plvc_user_role_name'] ) )
			return false;

		$record_base = strip_tags( $_POST['record_field'] );
		$user_role_to = strip_tags( $_POST['plvc_user_role_name'] );
		$user_role_from = strip_tags( $_POST['copy_from'] );

		$record_from = $record_base . '_' . $user_role_from;
		$record_to = $record_base. '_' . $user_role_to;

		if( $record_from == $record_to )
			return false;

		if( !empty( $_POST['list_type'] ) && $_POST['list_type'] == 'custom_posts' && !empty( $_POST['list_name'] ) ) {
			
			$list_name = strip_tags( $_POST['list_name'] );
			$FromData = get_option( $record_from );

			$custom_post_data = array();

			if( !empty( $FromData[$list_name] ) )
				$custom_post_data = $FromData[$list_name];

			$ToData = get_option( $record_to );
			$ToData[$list_name] = $custom_post_data;
			
		} else {
			
			$ToData = get_option( $record_from );
			
		}

		if( $Plvc->Current['multisite'] && $Plvc->Current['network_admin'] ) {
			
			//update_option( $record_to , $FromData );
			
		} else {

			update_option( $record_to , $ToData );

		}

		wp_redirect( add_query_arg( $Plvc->Plugin['msg_notice'] , 'update' ) );
		exit;
		
	}
	
	private function copy_original_data() {
		
		global $Plvc_Multiple;
		global $Plvc;

		if( empty( $_POST['data']['orignal'] ) or empty( $_POST['data']['user_role'] ) )
			return false;
		
		$original_record_name = strip_tags( $_POST['data']['orignal'] );
		$user_role = strip_tags( $_POST['data']['user_role'] );
		
		if( empty( $original_record_name ) or empty( $user_role ) )
			return false;

		$rewrite_records = $Plvc_Multiple->ClassConfig->get_rewrite_redords_name();

		if( empty( $rewrite_records[$original_record_name] ) )
			return false;

		$record_base = $rewrite_records[$original_record_name];

		$option_data = get_option( $record_base );
		
		$update_record = $record_base . '_' . $user_role;

		if( $Plvc->Current['multisite'] && $Plvc->Current['network_admin'] ) {
			
			//update_option( $record_to , $FromData );
			
		} else {

			update_option( $update_record , $option_data );

		}

		wp_redirect( add_query_arg( array( $Plvc_Multiple->Plugin['msg_notice'] => 'update_copy_original_data' ) ) );
		exit;

	}

}

endif;
