<?php

if ( !class_exists( 'Plvc_Multiple_Manager' ) ) :

class Plvc_Multiple_Manager
{

	var $select_user_role = '';

	function init() {
		
		global $Plvc_Multiple;
		global $Plvc;
		
		if( $Plvc->Current['admin'] && $Plvc->ClassManager->is_manager && !$Plvc->Current['ajax'] ) {
			
			$this->setup_select_user_role();

			$base_plugin = trailingslashit( $Plvc_Multiple->plugin_slug ) . $Plvc_Multiple->plugin_slug . '.php';

			add_filter( 'plugin_action_links_' . $base_plugin , array( $this , 'plugin_action_links' ) );
			add_action( 'admin_menu' , array( $this , 'admin_menu' ) );
			add_action( 'admin_print_scripts' , array( $this , 'admin_print_scripts' ) );
			add_action( 'admin_notices' , array( $this , 'update_notice' ) );
			
			add_action( 'admin_footer-toplevel_page_' . $Plvc->Plugin['page_slug'] , array( $this , 'disable_setting_user_role' ) );

			add_filter( 'plvc_get_apply_roles' , array( $this , 'print_user_roles_tab' ) );
			add_filter( 'plvc_form_items' , array( $this , 'add_form_items' ) );
			add_filter( 'plvc_form_before' , array( $this , 'data_copy_form' ) );
			
		}

	}

	function setup_select_user_role () {
		
		$this->select_user_role = 'administrator';

		if( !empty( $_GET['plvc_setting_role'] ) )
			$this->select_user_role = strip_tags( $_GET['plvc_setting_role'] );

	}

	function plugin_action_links( $links ) {

		global $Plvc_Multiple;
		global $Plvc;

		$link_setting = sprintf( '<a href="%1$s">%2$s</a>' , $Plvc_Multiple->Plugin['links']['setting'] , __( 'Settings' ) );
		$link_support = sprintf( '<a href="%1$s" target="_blank">%2$s</a>' , $Plvc_Multiple->Plugin['links']['contact'] , __( 'Contact' , $Plvc->Plugin['ltd'] ) );

		array_unshift( $links , $link_setting, $link_support );

		return $links;

	}

	function admin_menu() {
		
		global $Plvc_Multiple;
		global $Plvc;

		$cap = $Plvc->ClassManager->get_manager_user_role();
		$parent_slug = $Plvc->Plugin['page_slug'];

		add_submenu_page( $parent_slug , __( 'Multiple Setups' , $Plvc_Multiple->ltd ) , __( 'Multiple Setups' , $Plvc_Multiple->ltd ) , $cap , $Plvc_Multiple->main_slug , array( $this , 'views') );

	}

	function is_settings_page() {
		
		global $plugin_page;
		global $Plvc_Multiple;
		global $Plvc;
		
		$is_settings_page = false;
		$setting_pages = array( $Plvc_Multiple->main_slug );
		
		if( in_array( $plugin_page , $setting_pages ) )
			$is_settings_page = true;
			
		return $is_settings_page;

	}

	function admin_print_scripts() {
		
		global $Plvc_Multiple;
		global $Plvc;
		
		if( $this->is_settings_page() ) {
			
			$ReadedJs = array( 'jquery' , 'jquery-ui-sortable' );
			wp_enqueue_script( $Plvc->Plugin['page_slug'] ,  $Plvc->Plugin['url'] . $Plvc->Plugin['ltd'] . '.js', $ReadedJs , $Plvc->Ver );
			
			wp_enqueue_style( $Plvc->Plugin['page_slug'] , $Plvc->Plugin['url'] . $Plvc->Plugin['ltd'] . '.css', array() , $Plvc->Ver );

		}

	}

	function update_notice() {
		
		global $Plvc_Multiple;
		global $Plvc;

		if( $this->is_settings_page() ) {
			
			if( !empty( $_GET ) && !empty( $_GET[$Plvc_Multiple->Plugin['msg_notice']] ) ) {
				
				$update_nag = $_GET[$Plvc_Multiple->Plugin['msg_notice']];
				
				if( $update_nag == 'update_copy_original_data' ) {

					printf( '<div class="updated"><p><strong>%s</strong></p></div>' , __( 'Settings saved.' ) );

				}
				
			}
			
		}
		
	}

	function views() {

		global $Plvc_Multiple;
		global $Plvc;

		if( $this->is_settings_page() ) {
			
			$manage_page_path = $Plvc_Multiple->plugin_dir . trailingslashit( 'inc' );
			
			include_once $manage_page_path . 'setting.php';
			
		}
		
	}
	
	function disable_setting_user_role() {
		
		global $Plvc_Multiple;
		
?>
<script>
jQuery(document).ready(function($) {

	$Form = $('form#plvc_user_role_form');

	$Form.find('.postbox, .submit').remove();
	
	$('form#plvc_user_role_reset_form').remove();
	$('.wrap').children('p').hide();

	$Form.html( '<?php printf( '<p><strong style="color: red;">%1$s</strong><br />%2$s</p>' , __( 'Ready to set up multi can be used.' , $Plvc_Multiple->ltd ) , __( 'Please select in each list setting screen to select of user roles.' , $Plvc_Multiple->ltd ) ); ?>' );

});
</script>
<?php

	}
	
	function print_user_roles_tab( $Contents ) {

		global $plugin_page;
		global $Plvc;
		
		$all_user_roles = $Plvc->ClassConfig->get_all_user_roles();

		$Contents = '';
		foreach( $all_user_roles as $role_name => $user_role ) {
			
			$class = 'nav-tab ' . $role_name;

			if( $role_name == $this->select_user_role )
				$class .= ' nav-tab-active';
				
			$url = add_query_arg( array( 'page' => $plugin_page , 'plvc_setting_role' => $role_name ) , $Plvc->ClassManager->get_action_link() );
			
			$Contents .= sprintf( '<a href="%1$s" class="%2$s">%3$s</a>' , $url , $class , $user_role['label'] );
			
		}
		
		return $Contents;

	}
	
	function add_form_items() {
		
		printf( '<input type="hidden" name="plvc_user_role_name" value="%s" />' , $this->select_user_role );

	}

	function data_copy_form() {
		
		global $Plvc_Multiple;
		global $Plvc;

		$all_user_roles = $Plvc->ClassConfig->get_all_user_roles();
?>

		<div class="stuffbox data_copy_form">

			<form id="<?php echo $Plvc_Multiple->ltd; ?>_role_data_copy" class="<?php echo $Plvc_Multiple->ltd; ?>_form" method="post" action="<?php echo $Plvc->ClassManager->get_action_link(); ?>">

				<input type="hidden" name="<?php echo $Plvc->Plugin['form']['field']; ?>" value="Y">
				<?php wp_nonce_field( $Plvc_Multiple->ltd . '_role_data_copy' , $Plvc_Multiple->ltd . '_role_data_copy' ); ?>

				<?php do_action( 'plvc_form_items' ); ?>

				<?php if( !empty( $Plvc->ClassManager->menu_type ) ) : ?>
					<input type="hidden" name="record_field" value="<?php echo $Plvc->Plugin['record'][$Plvc->ClassManager->menu_type]; ?>" />
					<input type="hidden" name="menu_type" value="<?php echo $Plvc->ClassManager->menu_type; ?>" />
				<?php elseif( !empty( $Plvc->ClassManager->list_type ) ) : ?>
					<input type="hidden" name="record_field" value="<?php echo $Plvc->Plugin['record'][$Plvc->ClassManager->list_type]; ?>" />
					<input type="hidden" name="list_name" value="<?php echo $Plvc->ClassManager->list_name; ?>" />
					<input type="hidden" name="list_type" value="<?php echo $Plvc->ClassManager->list_type; ?>" />
				<?php endif; ?>

				<h3><span class="hndle"><?php _e( 'Please select only if you want to copy the settings data of other roles.' , $Plvc_Multiple->ltd ); ?></span></h3>
				<div class="inside">
					<p>
						<label>
							<?php _e( 'Copy settings data from' , $Plvc_Multiple->ltd ); ?>
							<select name="copy_from">
								<option value=""><?php _e( 'Choose user role' , $Plvc_Multiple->ltd ); ?></option>
								<?php foreach( $all_user_roles as $role_name => $user_role ): ?>
									<?php $disabled = disabled( $role_name , $this->select_user_role , false ); ?>
									<option value="<?php echo $role_name; ?>" <?php echo $disabled; ?>><?php echo $user_role['label']; ?></option>
								<?php endforeach; ?>
							</select>
						</label>
						<input type="submit" value="<?php _e( 'Copy Settings' , $Plvc_Multiple->ltd ); ?>" class="button button-primary" />
					</p>
				</div>
				
			</form>
		</div>

<?php
	}

}

endif;
