<?php
/*
Plugin Name: Post Lists View Custom Add on Multiple setups
Description: Add-on to the Post Lists View Custom for Multiple setups.
Plugin URI: http://gqevu6bsiz.chicappa.jp/post-lists-view-custom-for-multiple-setups-add-on/?utm_source=use_plugin&utm_medium=list&utm_content=plvc_ao_multiple&utm_campaign=1_7_1
Version: 1.7.1
Author: gqevu6bsiz
Author URI: http://gqevu6bsiz.chicappa.jp/?utm_source=use_plugin&utm_medium=list&utm_content=plvc_ao_multiple&utm_campaign=1_7_1
Text Domain: plvc_ao_multiple
Domain Path: /languages
*/




if ( !class_exists( 'Plvc_Multiple' ) ) :

class Plvc_Multiple
{

	public $name;
	public $ver;
	public $plugin_slug;
	public $main_slug;
	public $ltd;

	public $plugin_dir;
	public $plugin_url;

	var $Plugin = array();

	var $ClassConfig;
	var $ClassData;
	var $ClassManager;
	var $ClassInfo;

	function __construct() {}
	
	function init() {
		
		$this->define_constants();
		$this->includes();
		
		add_action( 'plvc_init' , array( $this , 'do_plvc_init' ) );

	}
	
	private function define_constants()
	{
		
		$this->name        = 'Post Lists View Custom for Multiple Setups';
		$this->ver         = '1.7.1';
		$this->plugin_slug = 'plvc-addon-multiple';
		$this->main_slug   = 'plvc_addon_multiple';
		$this->ltd         = 'plvc_ao_multiple';

        $this->plugin_dir  = plugin_dir_path( __FILE__ );
        $this->plugin_url  = plugin_dir_url( __FILE__ );

		load_plugin_textdomain( $this->ltd , false , $this->plugin_slug . '/languages' );

	}

	private function includes()
	{
		
		$inc_path = plugin_dir_path( __FILE__ );

		include_once $inc_path . 'inc/class-config.php';
		include_once $inc_path . 'inc/class-data.php';
		include_once $inc_path . 'inc/class-manager.php';
		include_once $inc_path . 'inc/class-plugin-info.php';

		$this->ClassConfig = new Plvc_Multiple_Config();
		$this->ClassData = new Plvc_Multiple_Data();
		$this->ClassManager = new Plvc_Multiple_Manager();
		$this->ClassInfo = new Plvc_Multiple_Plugin_Info();

	}
	
	public function do_plvc_init()
	{

		$this->ClassData->init();
		$this->ClassManager->init();
		$this->ClassInfo->init();

		add_action( 'wp_loaded' , array( $this , 'FilterStart' ) );

	}
	
	function FilterStart() {
		
		global $Plvc;
		
		if( !$Plvc->Current['network_admin'] && $Plvc->Current['admin'] ) {

			add_filter( 'plvc_pre_get_data' , array( $this , 'plvc_pre_get_data' ) , 10 , 2 );
			add_filter( 'plvc_pre_update' , array( $this , 'plvc_pre_update' ) );
			add_filter( 'plvc_pre_delete' , array( $this , 'plvc_pre_delete' ) );
			add_filter( 'plvc_pre_setting_roles' , array( $this , 'plvc_pre_is_apply_user' ) );
			add_filter( 'plvc_pre_get_filt_data' , array( $this , 'plvc_pre_get_filt_data' ) , 10 , 2 );

		}

	}



	function plvc_pre_get_data( $Data , $record ) {
		
		global $Plvc;
		
		$rewrite_records = $this->ClassConfig->get_rewrite_redords_name();

		if( in_array( $record , $rewrite_records ) ) {
			
			$active_role = strip_tags( $this->ClassManager->select_user_role );
			$user_role_record = $record . '_' . $active_role;
			
			$Data = get_option( $user_role_record );

		}
		
		return $Data;

	}

	function plvc_pre_update( $record ) {
		
		$active_role = strip_tags( $this->ClassManager->select_user_role );
		$record = $record . '_' . $active_role;

		return $record;
		
	}
	
	function plvc_pre_delete( $record ) {
		
		$active_role = strip_tags( $this->ClassManager->select_user_role );
		$record = $record . '_' . $active_role;

		return $record;
		
	}
	
	function plvc_pre_is_apply_user( $setting_roles ) {
		
		global $Plvc;
		
		$setting_roles = array( 'UPFN' => 1 );
		$current_role =  $Plvc->Current['user_role'];
		$setting_roles[$current_role] = 1;

		return $setting_roles;

	}
	
	function plvc_pre_get_filt_data( $Data , $record ) {
		
		global $Plvc;
		
		$active_role = $Plvc->Current['user_role'];
		$rewrite_records = $this->ClassConfig->get_rewrite_redords_name();
		
		if( in_array( $record , $rewrite_records ) ) {

			$user_role_record = $record . '_' . $active_role;
			
			$Data = get_option( $user_role_record );

		}
		
		return $Data;

	}

}

$GLOBALS['Plvc_Multiple'] = new Plvc_Multiple();
$GLOBALS['Plvc_Multiple']->init();

endif;
